<?php
   # This demonstrates how easy it is to use SOAP.  
   # -------------------------------------------------------------------------------
   # For more information on SOAP, go to: http://www.w3schools.com/soap/default.asp
   # For more information on WSDLs, go to: http://www.w3schools.com/wsdl/default.asp
   # -------------------------------------------------------------------------------
   # John Wallace - September 28, 2011 - http://jwallace.us
      
      
   echo PHP_EOL . "Soapy Weather (cli version)" . PHP_EOL . PHP_EOL;
   echo 'Enter your ZIP code > ';
   
   # get the zip code
   $str = fread(STDIN, 80);
   $zip_code = trim($str);
   
   # check zip code for non-numbers
   if (!ctype_digit($zip_code)) {
      die ("error: non-numbers were used in the zip code" . PHP_EOL);
   }
   echo PHP_EOL;
   
   # create a SOAP client using NOAA's WSDL
   $client = new SoapClient ("http://www.weather.gov/forecasts/xml/DWMLgen/wsdl/ndfdXML.wsdl");
   $dxml = new SimpleXMLElement($client->LatLonListZipCode($zip_code));
   # get the latitude and longitude of the zip code
   $location = preg_split ('/(,)/',$dxml->latLonList);

   # setting a time zone is required to use the date function
   date_default_timezone_set('America/Chicago');  
   $dateTime = date("c");

   # get the current weather
   $dxml = new SimpleXMLElement($client->NDFDgen($location[0],$location[1], 'time-series', $dateTime, $dateTime, 'e', 'temp'));
   echo "Current conditions for $zip_code (" . $dxml->data->location->point['latitude'] . "," . $dxml->data->location->point['longitude'] . ") are: " . PHP_EOL . PHP_EOL;
   
   # now parse and present the weather data returned in an XML format
   foreach ($dxml->data->parameters as $parameter) {
      foreach ($parameter as $element) {
         if (count($element) > 1) {
            if ($element->value != "") {
               echo $element->name . ": [" . $element->value . "]" . PHP_EOL;
            }
         }
         else {
            foreach ($element as $sub_element) {
               if ($element->value != "") {
                  echo $sub_element->name . ": [" . $sub_element->value . "]" . PHP_EOL;
               }
            }
         }
      }
   }
   echo PHP_EOL . "Done!" . PHP_EOL;   
?>
